<?php
// $Id: settings_domain_prefix.inc,v 1.4 2008/01/27 22:31:14 agentken Exp $

/**
 * @file
 * Dynamic domain table prefix loading.
 *
 * Loads the table prefixes for the current domain.
 */
 
_drupal_bootstrap(DRUPAL_BOOTSTRAP_DATABASE);
_domain_prefix_load();

/**
 * Load the prefixes for this subdomain
 *
 * @ingroup prefix
 */
function _domain_prefix_load() {
  $check = db_result(db_query("SELECT status FROM {system} WHERE name = 'domain_prefix'"));
  if ($check) {
    // Cribbed from bootstrap.inc -- removes port protocols from the host value.
    $_subdomain = strtolower(implode('.', array_reverse(explode(':', rtrim($_SERVER['HTTP_HOST'], '.')))));
    // Strip the www. off the subdomain, if required.
    if (variable_get('domain_www', 0)) {
      $_subdomain = str_replace('www.', '', $_subdomain);
    }
    // Lookup the active domain against our allowed hosts record.
    $domain = db_fetch_array(db_query("SELECT domain_id FROM {domain} WHERE subdomain = '%s'", $_subdomain));
    if ($domain['domain_id']) {
      $tables = array();
      $prefix = 'domain_'. $domain['domain_id'] .'_';
      $result = db_query("SELECT tablename FROM {domain_prefix} WHERE domain_id = %d AND status > 1", $domain['domain_id']);
      while ($data = db_fetch_array($result)) {
        $tables[] = $data['tablename'];
      }
      if (!empty($tables)) {
        global $db_prefix;
        $new_prefix = array();
        // There might be global prefixing; if so, prepend the global.
        if (is_string($db_prefix)) {
          $new_prefix['default'] = $db_prefix;
          $prefix = $db_prefix . $prefix;
        }
        foreach($tables as $table) {
          $new_prefix[$table] = $prefix;
        }
        $db_prefix = $new_prefix;
      }
    }
  }
}
